package com.example.fuzzControll.tools;

import java.io.*;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

import com.alibaba.fastjson.JSONObject;
import com.example.fuzzControll.pojo.vo.TestReturnEntity;
import org.apache.commons.io.IOUtils;
import com.jcraft.jsch.ChannelExec;
import com.jcraft.jsch.JSch;
import com.jcraft.jsch.JSchException;
import com.jcraft.jsch.Session;
import org.apache.tomcat.util.buf.Utf8Decoder;


public class LinuxCommandUtil {

    private Session session;
    private ChannelExec channelExec;

    /**
     * 默认执行本地linux指令
     */
    public static String exeLocLinuxCmd(String cmd) {
        String result = "";
        Runtime run = Runtime.getRuntime();
        try {
            Process process = run.exec(cmd);
            InputStream in = process.getInputStream();
            BufferedReader bs = new BufferedReader(new InputStreamReader(in));
            process.destroy();
            return result;
        } catch (IOException e) {
            e.printStackTrace();
        }
        return null;
    }

    /**
     * 远程执行linux指令
     */
    public static String exeLinuxBySSH(String host, int port, String user, String password, String command) throws JSchException, IOException {

        JSch jsch = new JSch();
        Session session = jsch.getSession(user, host, port);
        session.setConfig("StrictHostKeyChecking", "no");

        session.setPassword(password);
        session.connect();

        ChannelExec channelExec = (ChannelExec) session.openChannel("exec");
        InputStream in = channelExec.getInputStream();
        channelExec.setCommand(command);
        channelExec.setErrStream(System.err);
        channelExec.connect();
        String out = IOUtils.toString(in, "UTF-8");

        channelExec.disconnect();
        session.disconnect();

        return out;
    }

    /**
     * 创建连接
     */
    public Session connect(String host, int port, String user, String password) throws JSchException {
        JSch jsch = new JSch();
        session = jsch.getSession(user, host, port);
        session.setConfig("StrictHostKeyChecking", "no");

        session.setPassword(password);
        session.connect();

        channelExec = (ChannelExec) session.openChannel("exec");
        return session;
    }

    /**
     * 执行指令
     */
    public void execCmd(String command) throws JSchException, IOException {
        InputStream in = channelExec.getInputStream();
        InputStream error = channelExec.getErrStream();
        new Thread(new Runnable() {
            @Override
            public void run() {
                outPutStream(in);
            }
        }).start();
        new Thread(new Runnable() {
            @Override
            public void run() {
                errorStream(error);
            }
        }).start();
        channelExec.setCommand(command);
        channelExec.connect();
    }

    /**
     * 不需要结果执行指令
     */
    public void execCmdWithoutResults(String command) throws JSchException, IOException {
        InputStream in = channelExec.getInputStream();
        InputStream error = channelExec.getErrStream();
//        new Thread(new Runnable() {
//            @Override
//            public void run() {
////                trainOutPutStream(in);
//            }
//        }).start();
//        new Thread(new Runnable() {
//            @Override
//            public void run() {
//                errorStream(error);
//            }
//        }).start();
        channelExec.setCommand(command);
        channelExec.connect();
    }

    public void outPutStream(InputStream in) {
        Reader reader = new InputStreamReader(in);
        BufferedReader bf = new BufferedReader(reader);
        String line = null;
        List<String> list = new ArrayList<>();
        ;
        try {
            while ((line = bf.readLine()) != null && TestControlTools.getIsRunning()) {
                System.out.println(line);
                if (line.contains("american fuzzy")) {
                    list = new ArrayList<>();
                }
                if (list != null)
                    list.add(line + "\n");
                if (line.contains("cpu") || line.contains("%]") ) {
                    GlobalParameters.webSocket.appointSending("fuzzMaster", "web", list.toString());
                }
            }
            //结束就关闭
            if (!TestControlTools.getIsRunning()) {
                close();
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

//    public void trainOutPutStream(InputStream in) {
//        Reader reader = new InputStreamReader(in);
//        BufferedReader bf = new BufferedReader(reader);
//        String line = null;
//        try {
//            while ((line = bf.readLine()) != null && TestControlTools.getIsRunning()) {
//                System.out.println(line);
////                GlobalParameters.webSocket.appointSending("fuzzMaster", "webTrainResult", line);
//            }
//            //结束就关闭
//            if (!TestControlTools.getIsRunning()) {
//                close();
//            }
//        } catch (IOException e) {
//            e.printStackTrace();
//        }
//    }

    public void errorStream(InputStream error) {
        Reader reader = new InputStreamReader(error);
        BufferedReader bf = new BufferedReader(reader);
        String line = null;
        List<String> list = null;
        try {
            while ((line = bf.readLine()) != null && TestControlTools.getIsRunning()) {
                System.out.println(line);
            }
            //结束就关闭
            if (!TestControlTools.getIsRunning()) {
                close();
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * 关闭连接
     */
    public void close() {
        channelExec.disconnect();
        session.disconnect();
    }
}