package com.example.fuzzbackendmaster.controller;


import com.example.fuzzbackendmaster.pojo.vo.AjaxResult;
import com.example.fuzzbackendmaster.service.FuzzIntegrationFileApi;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;


/**
 * kitty服务器信息
 */
@RestController
@RequestMapping("/kittyServer")
@Slf4j
public class KittyServerMessageController {

    @Autowired
    FuzzIntegrationFileApi fuzzIntegrationFileApi;

    /**
     * 获取服务器stats信息
     */
    @RequestMapping(value = "/stats", method = RequestMethod.GET)
    public AjaxResult getStats() {
        return fuzzIntegrationFileApi.getStats();
    }

    /**
     * 获取服务器templateInfo信息
     */
    @RequestMapping(value = "/templateInfo", method = RequestMethod.GET)
    public AjaxResult getTemplateInfo() {
        return fuzzIntegrationFileApi.getTemplateInfo();
    }

    /**
     * 获取服务器stages信息
     */
    @RequestMapping(value = "/stages", method = RequestMethod.GET)
    public AjaxResult getStages() {
        return fuzzIntegrationFileApi.getStages();
    }

    /**
     * 获取服务器report信息
     */
    //todo 了解该功能使用方式
    @RequestMapping(value = "/report", method = RequestMethod.GET)
    public AjaxResult getReport() {
        return fuzzIntegrationFileApi.getReport();
    }
}