package com.example.fuzzbackendmaster.controller;


import com.example.fuzzbackendmaster.exception.CmdException;
import com.example.fuzzbackendmaster.exception.FuzzException;
import com.example.fuzzbackendmaster.pojo.vo.AjaxResult;
import com.example.fuzzbackendmaster.pojo.vo.TestEntity;
import com.example.fuzzbackendmaster.service.FuzzIntegrationFileApi;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.Map;

/**
 * 不同类型的测试方法
 */
@Slf4j
@RestController
@RequestMapping("/testClass")
public class TestClassController {

    @Autowired
    FuzzIntegrationFileApi fuzzIntegrationFileApi;

    /**
     * 模板
     */
    @RequestMapping(value = "/protocolTemplate", method = RequestMethod.POST)
    public AjaxResult protocolTemplate(@RequestBody TestEntity testEntity) {
        return fuzzIntegrationFileApi.protocolTemplate(testEntity);
    }

    /**
     * 生成方法
     */
    @RequestMapping(value = "/generate", method = RequestMethod.POST)
    public AjaxResult generate(@RequestBody TestEntity testEntity) {
        return fuzzIntegrationFileApi.generate(testEntity);
    }

    /**
     * 变异方法
     */
    @RequestMapping(value = "/mutation", method = RequestMethod.POST)
    public AjaxResult mutation(@RequestBody TestEntity testEntity) {
        return fuzzIntegrationFileApi.mutation(testEntity);
    }

    /**
     * 漏洞类型
     */
    @RequestMapping(value = "/vulnerabilityType", method = RequestMethod.POST)
    public AjaxResult upload(@RequestBody TestEntity testEntity) {
        return fuzzIntegrationFileApi.vulnerability(testEntity);
    }
}
