package com.example.fuzzbackendmaster.controller;

import com.example.fuzzbackendmaster.pojo.vo.AjaxResult;
import com.example.fuzzbackendmaster.pojo.vo.CmdStartParams;
import com.example.fuzzbackendmaster.service.FuzzIntegrationFileApi;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

/**
 * aflnet测试控制
 */
@Slf4j
@RestController
@RequestMapping("/test")
public class TestController {
    @Autowired
    FuzzIntegrationFileApi fuzzIntegrationFileApi;

    /**
     * 测试启动
     */
    @RequestMapping(value = "/testStart", method = RequestMethod.POST)
    public AjaxResult testStart(@RequestBody final CmdStartParams cmdStartParams) {
        //启动时就开始连接
        fuzzIntegrationFileApi.connect();
        return fuzzIntegrationFileApi.testStart(cmdStartParams);
    }

    /**
     * 测试停止
     */
    @RequestMapping(value = "/testStop", method = RequestMethod.GET)
    public AjaxResult testStop() {
        //停止时就开始关闭
        fuzzIntegrationFileApi.disconnect();
        return fuzzIntegrationFileApi.testStop();
    }

}