package com.example.fuzzbackendmaster.service.impl;

import com.example.fuzzbackendmaster.pojo.vo.FuzzLogTransEntity;
import com.example.fuzzbackendmaster.service.FuzzIntegrationFileApi;
import com.example.fuzzbackendmaster.service.FuzzLogService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.servlet.http.HttpServletResponse;
import java.io.OutputStream;

@Service("FuzzLogService")
public class FuzzLogServiceImpl implements FuzzLogService {
    @Autowired
    FuzzIntegrationFileApi fuzzIntegrationFileApi;

    @Override
    public void getFuzzLog(int missionId, HttpServletResponse response) throws IllegalAccessException {
        FuzzLogTransEntity fuzzLogTransEntity = fuzzIntegrationFileApi.getFuzzLog(missionId);
        if (fuzzLogTransEntity == null && fuzzLogTransEntity.getFile() == null) {
            throw new IllegalStateException();
        }
        downloadFile(fuzzLogTransEntity.getName(), fuzzLogTransEntity.getFile(), response);
    }

    /**
     * 浏览器前端下载后台文件,文件为二进制格式
     */
    public void downloadFile(String fileName, byte[] file, HttpServletResponse response) {
        if (fileName != null && !"".equals(fileName)) {
            if (file != null && file.length != 0) {
                response.setContentType("application/force-download");// 设置强制下载不打开
                response.addHeader("Content-Disposition", "attachment;fileName=" + fileName);// 设置文件名
                try (OutputStream os = response.getOutputStream();) {
                    os.write(file, 0, file.length);
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        }
    }
}
